﻿using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace SmartPhoneAlbum
{
	/// <summary>
	/// Summary description for form.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private ListView lstShowImg;
		private ImageList imgThumbnail;
		private Image imgThumb;
		private string[] fullPath;
		private int depth;
		private Image folderIcon;
		private Image fileIcon;
	
		private MainMenu mainMenu2;
		private MenuItem mnuUpDir;
		private MenuItem mnuQuit;
		private string fileT;
		public frmMain()
		{
			InitializeComponent();
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lstShowImg = new System.Windows.Forms.ListView();
			this.imgThumbnail = new System.Windows.Forms.ImageList();
			this.mainMenu2 = new System.Windows.Forms.MainMenu();
			this.mnuUpDir = new System.Windows.Forms.MenuItem();
			this.mnuQuit = new System.Windows.Forms.MenuItem();
// 
// lstShowImg
// 
			this.lstShowImg.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			this.lstShowImg.Location = new System.Drawing.Point(0, 1);
			this.lstShowImg.ItemActivate += new System.EventHandler(this.lstShowImg_ItemActivate);
// 
// imgThumbnail
// 
			this.imgThumbnail.ImageSize = new System.Drawing.Size(32, 32);
			this.imgThumbnail.Images.Clear();
// 
// mainMenu2
// 
			this.mainMenu2.MenuItems.Add(this.mnuUpDir);
			this.mainMenu2.MenuItems.Add(this.mnuQuit);
// 
// mnuUpDir
// 
			this.mnuUpDir.Text = "Bir Ust";
			this.mnuUpDir.Click += new System.EventHandler(this.mnuUpDir_Click);
// 
// mnuQuit
// 
			this.mnuQuit.Text = "Çıkış";
			this.mnuQuit.Click += new System.EventHandler(this.mnuQuit_Click);
// 
// frmMain
// 
			this.ClientSize = new System.Drawing.Size(176, 180);
			this.Controls.Add(this.lstShowImg);
			this.Menu = this.mainMenu2;
			this.Text = "SmartPhoneAlbum";
			this.Load += new System.EventHandler(this.frmMain_Load);

		}

		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			base.Dispose(disposing);
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		static void Main()
		{
			Application.Run(new frmMain());
		}

		private void frmMain_Load(object sender, EventArgs e)
		{
			System.Reflection.Assembly exAs = System.Reflection.Assembly.GetExecutingAssembly();
//Dosya ve klasörleri simgeleyecek ikonları embedded resource yapıp Assembly'den okuyoruz
			fullPath = new string[128];
			folderIcon = new Bitmap(exAs.GetManifestResourceStream(@"SmartPhoneAlbum.foldericon.bmp"));
			fileIcon = new Bitmap(exAs.GetManifestResourceStream(@"SmartPhoneAlbum.fileicon.bmp"));
			imgThumbnail.Images.Add(folderIcon);
			imgThumbnail.Images.Add(fileIcon);
//imgThumbnail ListView control'ünün büyük resimlerini içeren bir liste oluşturacak
			lstShowImg.LargeImageList = imgThumbnail;
//fullPath string dizisi bizim hangi klasörde bulunduğumuzu dizinleyip bir nevi gittiğimiz yolları
//yolları kaydedip geri dönüşümüz için bilgi sağlayacak.
			fullPath[0]=@"\";
//ShowDir fonksiyonu fullPath'den okuduğu yol bilgisiyle dosya ve klasörleri ListView'de görüntületecek
			ShowDir(fullPath[0]);

		}
		private void ShowDir(string newdir)
		{
			string[] dirs;
			string[] files;
			string shortdir;
			string shortfile;
			string lvidir;
			string lviFile;

			Cursor.Current = Cursors.WaitCursor;
			//Klasörler belirleniyor
			try
			{
				dirs = Directory.GetDirectories(newdir);
				files = Directory.GetFiles(newdir);
			}
			catch (Exception ex)
			{
				--depth;
				return;
			}

			lstShowImg.Items.Clear();
		
			if (depth != 0)
			{
				ListViewItem lvi = new ListViewItem("..");
				lvi.ImageIndex = 0;
				lstShowImg.Items.Add(lvi);
				
			}
			lstShowImg.BeginUpdate();
			foreach (string dir in dirs)
			{
				if (depth == 0)
					shortdir = dir;
				else
					shortdir = dir.Remove(0, newdir.Length);

				lvidir = shortdir.Remove(0, 1);
				ListViewItem lvi = new ListViewItem(lvidir);
				lvi.ImageIndex = 0;
				lstShowImg.Items.Add(lvi);
			}
			int i = 1;
			//Dosyalar tanımlanıyor, Resim dosyaları bir if döngüsüyle kontrol edilip 
			//resim dosyası olan imgThumnail'in içine atılıyor.
			foreach (string file in files)
			{
				if (depth == 0)
				{
					shortfile = file;
					fileT = file;
				}
				else
					shortfile = file.Remove(0, newdir.Length);

				lviFile = shortfile.Remove(0, 1);
				ListViewItem lvi = new ListViewItem(lviFile);
				
				if (lviFile.EndsWith(".JPG") || lviFile.EndsWith(".jpg") || lviFile.EndsWith(".GIF") || lviFile.EndsWith(".gif") || lviFile.EndsWith(".BMP") || lviFile.EndsWith(".bmp"))
				{
					i++;
					imgThumb = new Bitmap(file);
					imgThumbnail.Images.Add(imgThumb);
					lvi.ImageIndex = i;	
				}
				else
				{
					lvi.ImageIndex = 1;
				}
				lstShowImg.Items.Add(lvi);

			}
			lstShowImg.EndUpdate();
			Cursor.Current = Cursors.Default;

		}

		private void lstShowImg_ItemActivate(object sender, EventArgs e)
		{
			
			string nextPath;
			
			ListViewItem lvi = lstShowImg.Items[lstShowImg.SelectedIndices[0]];

			if (lvi.Text != "..")
			{
				
				++depth;

				if (depth == 1)
				{	
					nextPath = lvi.Text;
				}
				else
					nextPath = @"\" + lvi.Text;

				
				fullPath[depth] = fullPath[depth - 1] + nextPath;
			}
			else
			{
				
				--depth;

			}

			//Seçili dosya resim ise yeni bir formda görüntüleniyor
			//Burada ayrıca bir smartphone uygulamasında multiform nasıl kullanılır? Sorusuna cevapta
			//aşağıdaki kod ile veriliyor.
			if (fullPath[depth].EndsWith(".jpg") || fullPath[depth].EndsWith(".bmp") || fullPath[depth].EndsWith(".gif") || fullPath[depth].EndsWith(".JPG") || fullPath[depth].EndsWith(".BMP") || fullPath[depth].EndsWith(".GIF"))
			{
				frmShow frm = new frmShow(this);
				frm.strImgFile = fullPath[depth];
				--depth;
				frm.ShowDialog();
				
			}
			else
			{

				imgThumbnail.Images.Clear();
				imgThumbnail.Images.Add(folderIcon);
				imgThumbnail.Images.Add(fileIcon);
				ShowDir(fullPath[depth]);
				

			}
		}

		private void mnuUpDir_Click(object sender, EventArgs e)
		{
			if (depth != 0)
				--depth;
			ShowDir(fullPath[depth]);
		}

		private void mnuQuit_Click(object sender, EventArgs e)
		{
			Application.Exit();
		}
	}
}

